//========================================================================================
//	Release Version:	$ ODF 2 $
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.

//================================================================================
#include "DataSave.hpp"

#ifndef PART_H
#include "Part.h"
#endif

#ifndef CONTENT_H
#include "Content.h"
#endif

#ifndef BINDING_K
#include "Binding.k"
#endif

#ifndef DEFINES_K
#include "Defines.k"
#endif

#ifndef FRAME_H
#include "Frame.h"
#endif

// ----- Framework Layer -----
#ifndef FWPRESEN_H
#include "FWPresen.h"		// FW_CPresentation
#endif

#ifndef FWABOUT_H
#include "FWAbout.h"		//::FW_About()
#endif

//==============================================================================
#ifdef FW_BUILD_MAC
#pragma segment DataSave
#endif

FW_DEFINE_AUTO(CDataSavePart)

//==============================================================================
CDataSavePart::CDataSavePart(ODPart* odPart)
  :	FW_CPart(odPart, FW_gInstance, kPartInfoID),
	fPresentation(NULL),
	fPartContent(NULL)
{
	FW_END_CONSTRUCTOR
}

//--------------------------------------------------------------------------------
CDataSavePart::~CDataSavePart()
{
	FW_START_DESTRUCTOR
}

//--------------------------------------------------------------------------------
void 
CDataSavePart::Initialize(Environment* ev, ODStorageUnit* storageUnit, 
							FW_Boolean fromStorage)	// Override
{
	FW_CPart::Initialize(ev, storageUnit, fromStorage);
	FW_CSelection* selection = NULL;
	const ODType kMainPresentation = "Apple:Presentation:DataSave";
	const FW_Boolean kDefaultPresentation = true;
	fPresentation = RegisterPresentation(ev, kMainPresentation, 
											kDefaultPresentation, selection);
}

//--------------------------------------------------------------------------------
FW_Handled 
CDataSavePart::DoAbout(Environment* ev)	// Override
{
	::FW_About(ev, this, kAbout);
	
	return FW_kHandled;
}

//--------------------------------------------------------------------------------
FW_CFrame* 
CDataSavePart::NewFrame(Environment* ev, ODFrame* odFrame,
						FW_CPresentation* presentation, FW_Boolean fromStorage)	// Override
{
	FW_UNUSED(fromStorage);
	return FW_NEW(CDataSaveFrame, (ev, odFrame, presentation, fPartContent));
}

//------------------------------------------------------------------------------
FW_CContent* 
CDataSavePart::NewPartContent(Environment* ev)
{
	fPartContent = FW_NEW(CDataSaveContent, (ev, this));
	return fPartContent;
}

//------------------------------------------------------------------------------
void 
CDataSavePart::MyInvalidatePresentation(Environment* ev, FW_CRect& rect)
{
	fPresentation->Invalidate(ev, rect);
}
